function sig=gensig_ica(N,para)
% GENSIG  ---- generate four artificial signals with zero mean and unit variance.
% ??????
%     sig=gensig(N,para)
%   sig??????????????????????????????????????????????????????????????
%   ??????????????????????????????
%   ??????????????????????????????????????????????????????????
%
% ??????
%     ????????   N  ???? ??????????????????????????????500
%             para  ???? ????'on' ??????????????;'off'??????????????????????????'on'
% ??????????
%     sig=gensig(N,'on'); sig=gensig(N,'off');
%     sig=gensig(N);
%     sig=gensig;                  
%
% ??????????????Zhang Zhi-Lin??
%       http://teacher.uestc.edu.cn/teacher/teacher.jsp?TID=zzl80320
% ??????1.1
% ??????2003??10??30??


%====================================================================
% ????????
if(nargin<2) para='on'; end;   % para????????????????????????????
if(nargin<1) N=500;  end;   % N??????????????500??

%====================================================================
% ????????????
switch lower(para)
    case 'on'
        show=1;
    case 'off'
        show=0;
    otherwise
        error(sprintf('Illegal value [ %s ] for parameter: ''para''\n', para));
end

%====================================================================
% ????????
v=[0:N-1];
sig(1,:)=sin(v/2);   % ????????
sig(2,:)=((rem(v,23)-11)/9).^5; % ????????
%sig(2,:)=4*sin(v/2);
sig(3,:)=((rem(v,27)-13)/9);    % ????????
sig(4,:)=((rand(1,N)<.5)*2-1).*log(rand(1,N)); % ????????

if(show)    % ????????
    figure;
    subplot(4,1,4); 
        plot(sig(4,[N-499:N])); ylabel('????????');axis([-inf,inf,-5,5]);
    subplot(4,1,3); 
        plot(sig(3,[N-499:N])); ylabel('????????');axis([-inf,inf,-5,5]);
    subplot(4,1,2); 
        plot(sig(2,[N-499:N])); ylabel('????????');axis([-inf,inf,-5,5]);
    subplot(4,1,1); 
        plot(sig(1,[N-499:N])); ylabel('????????'); title('\bf\fontsize{14}????????');
        axis([-inf,inf,-5,5]);
end

sig = standardize(sig);       % ????????????????????????



